; DirectX7 Rumble Dll - BY: Todd Riggins aka: Pepsi - FREEWARE
; Demo #3 - Dynamic FFB Effect! Left mouse button in box area to change effect!

Global swidth=800
Global sheight=600
Graphics swidth,sheight,0,2
SetBuffer BackBuffer()

; Init DLL
di7=SystemProperty$("DirectInput7")
hwnd=SystemProperty$("AppHWND")
DX7RUMBLE_INIT%(hwnd, di7, 1)

; Get Number of Game Devices
Global totalgamedevices=TOTAL_GAMEDEVICES%()

For j=0 To (totalgamedevices-1)
	FFB_AUTOCENTER%(j,0)
Next

Global customeffect1=CREATE_EFFECT%()
SET_EFFECT_SAMPLEPERIOD(customeffect1,0)
SET_EFFECT_AXES(customeffect1,2,1,0,0)
SET_EFFECT_DURATION(customeffect1,0,1)
SET_EFFECT_GAIN(customeffect1,10000)
SET_EFFECT_CONSTANTFORCE(customeffect1,0,0)
For j=0 To (totalgamedevices-1)
		If FFB_AVAIL%(j)
			If ATTACH_EFFECT%(j,customeffect1)=0
				;;RuntimeError "Failed: Effect unable to attach to game device!"
			Else
		
			; HAS_EFFECT_SUPPORT and HAS_DYNAMIC_EFFECT_SUPPORT will write there results in the
			; DX7Rumble_debug.txt file if you have the last parameter set to true of the DX7RUMBLE_INIT command.
			For i=0 To 6
				HAS_EFFECT_SUPPORT%(j,customeffect1,i)
			Next		
			For i=0 To 6
				HAS_DYNAMIC_EFFECT_SUPPORT%(j,customeffect1,i)
			Next		
		EndIf
	EndIf
Next


; Variables applied to change ffb during runtime
Global gXForce=0
Global gYForce=0

MoveMouse swidth/2,sheight/2

; Red dot will move to mouse position inside the box area
; Further away from the center of the box, the stronger the FFB effect!
Global dotx=swidth/2
Global doty=sheight/2


Global magnitude=0
PLAY_EFFECT%(customeffect1) ; Constant force magnitude is set to zero so playing the initial effect here you wont feel anything.
; the gXForce,gYForce vars will change during runtime, then will update the magnitude of the constant force, then will
; get updated by the UPDATE_EFFECT command where then you will feel the FFB " rumble " change.

;Blitz3d Blue
ClsColor 34,85,119
While Not KeyDown(1)

	; Poll for Game Device(s) updated info 
	DX7RUMBLE_POLL()
	Cls
	
	; Crosshair marks the center
	Color 0,0,0
	Line swidth/2-25+1,sheight/2+1,swidth/2+25+1,sheight/2+1
	Line swidth/2+1,sheight/2-25+1,swidth/2+1,sheight/2+25+1
	Color 255,255,255
	Line swidth/2-25,sheight/2,swidth/2+25,sheight/2
	Line swidth/2,sheight/2-25,swidth/2,sheight/2+25
	; Draw Box (boundry to keep dot in)
	Color 0,0,0
	Rect swidth/2-100+1,sheight/2-100+1,200,200,0
	Color 0,255,255
	Rect swidth/2-100,sheight/2-100,200,200,0
	; Draw Dot
	Color 0,0,0
	Oval dotx+2-6,doty+2-6,12,12,1
	Color 255,0,0
	Oval dotx-6,doty-6,12,12,1
	
	
	; Text Info
	Color 0,255,0	
	Text 0,0,"; DirectX7 Rumble Dll - BY: Todd Riggins aka: Pepsi - FREEWARE"
	Text 0,15,"; Demo #3 - Dynamic FFB Effect! Left mouse button in box area to change effect! Press Escape to Exit!"
	
	Color 255,255,255	
	For j=0 To (totalgamedevices-1)
		; Print Game Device Name on Screen
		Text 0,45+(j*60),"("+Str$(j)+") "+GAMEDEVICE_NAME$(j)
		
		; Dynamically change effect during runtime!
		If FFB_AVAIL%(j)
			Text 0,60+(j*60),"Force FeedBack IS Available - magnitude="+Str$(magnitude*100)
			SetJoyForcesXY()
		Else
			Text 0,60+(j*60),"Force FeedBack NOT Available"
			Text 0,75+(j*60),"No Effect Will Play!"
		EndIf
	Next 
	
	Flip
Wend

STOP_EFFECT%(customeffect1)
; Release Dll's Aquired Memory!
DX7RUMBLE_RELEASE()
End


; Apply updated forces
Function SetJoyForcesXY()
	; Get changed values
	If MouseX()>swidth/2-100
		If MouseX()<swidth/2+100
			If MouseY()>sheight/2-100
				If MouseY()<sheight/2+100
					If MouseDown(1)
						dotx=MouseX()
						doty=MouseY()
						gXForce=dotx-swidth/2
						gYForce=doty-sheight/2
						
	; Modifying an effect is like creating a new one, but here
	; you only need to specify the parameters you are modifying...
	CLEAR_EFFECT(customeffect1) ; ie: zero it out
	
	; NOT working properly. I dont have a gameport to use my old FFB joystick.
	; gXForce and gYForce is suppose to use Polar Angular Values ( ie: 0 to 36000 )
	; so i have no idea if changing the effect axes with Cartesian Vector Style Values will work.
	; if you can make a new example of this and change it to work with polar angles
	; i would apprieciate that...
	; Simply change the directiontype parameter of SET_EFFECT_AXES to 0 from 1 for polar.
	SET_EFFECT_AXES(customeffect1,2,1,gXForce,gYForce)
	
	magnitude=Sqr((gXForce*gXForce)+(gYForce*gYForce))
	If magnitude>100 Then magnitude=100
	If magnitude<10 Then magnitude=0
	SET_EFFECT_CONSTANTFORCE(customeffect1,0,magnitude*100)
	UPDATE_EFFECT%(customeffect1,1,0,1,0,0,0,0,0)
						
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
End Function